import java.io.*;
import java.net.*;
import java.lang.reflect.*;
import java.util.*;

public class ClientHandler extends FileManager
{
	private static final byte USER=(byte)0;
	private static final byte SERVER=(byte)1;
	private static final byte[] PS1="Saka:".getBytes();
	private static final byte[] PS2=">".getBytes();
	private static final String BY="by";
	private static final byte [] OPTION="Dosyanin uzerine yazmak istiyor musunuz?:Evet(e), Tumune Evet(E), Hayir(h), Tumune Hayir(H): ".getBytes();
	private static final String EXIT="exit";
	private String remote_pwd;
	private byte [] REMOTE_PWD;
	private BufferedReader stdin;
	private byte caller;

	public ClientHandler(String host,int port) throws Exception
	{
		super(new Socket(host,port),new File(System.getProperty("user.dir")));
		stdin=new BufferedReader(new InputStreamReader(System.in));
		caller=USER;
	}

	public void userMessage(byte command,String message,byte cont)
	{
		if (command != 100) {
			System.out.println(message);
		}
	}

	public void peerMessage(byte command,String message,byte cont)
	{
		super.userMessage(command,message,cont);
	}

	public void screenMessage(String message)
	{
		System.out.print(message);
	}

	public void screenMessage(char ch)
	{
		System.out.print(ch);
	}

	public void get(String [] cmd)
	{
		System.out.println("Hata: Boyle bir komut yok");
	}

	public void mget(String [] cmd,String cmdStr)
	{
		System.out.println("Hata: Boyle bir komut yok");
	}

	public byte getUserChoice(String file)
	{
		String choice;
		try {
			System.out.print("Dosya "+file+" mevcut! ");
			do {
				System.out.write(OPTION,0,OPTION.length);
				choice=stdin.readLine();
			} while (choice.charAt(0) != 'e' && choice.charAt(0) != 'E'
				&& choice.charAt(0) != 'h' && choice.charAt(0) != 'H');
			switch (choice.charAt(0)) {
				case 'E' :
					not_yes_all=false;
					return (byte)3;
				case 'e' :
					return (byte)2;
				case 'h' :
					no_to_all=true;
					return (byte)1;
				default :
					return (byte)0;
			}
		} catch (Exception e) {
			System.err.println("Beklenmedik Durum: "+e.getMessage());
		}
		return (byte)0;
	}

	private void getFile()
	{
		try {
			if (downloadFile(getAbsoluteFile(reply)) == FM_DOWNLOAD_OK) {
				return;
			}
		} catch (SocketException se) { }
		catch (Exception e) {
			try {
				System.out.println("Beklenmedi Durum: "+e.getMessage());
				writeByte(0);
			} catch (SocketException se) {}
		}
	}

	private void processResponse()
	{
		do {
			readCommand();
			switch (r_type) {
				case 0 :
				case 1 :
					System.out.println(reply);
					break;
				case 2 :
					System.out.println(reply);
				case 5 :
					remote_pwd=reply;
					REMOTE_PWD=remote_pwd.getBytes();
					break;
				case 3 :
					getFile();
					break;
				case 4 :
					mkdir();
					break;
				case 6 :
					try {
						if (changeLocalPWD(reply)) {
							writeByte(1);
						} else {
							writeByte(0);
						}
					} catch (SocketException se) { }
					break;
				case 7 :
					try {
						writeLine(local_pwd.getAbsolutePath().getBytes());
					} catch (SocketException se) { }
					break;
				case 9 :
					super.get(splitCommand(reply),reply);
					break;
				case 10:
					super.mget(splitCommand(reply),reply);
					break;
				case 100 :
					break;
				case -1 :
					System.err.println("Hata: Sunucu baglantiyi kesti");
					return;
				default:
					System.err.println("Hata: Iletisim kurali hatasi. Sunucu cevabi("+r_type+")");
					not_exit=false;
					break;
			}
		} while (not_exit && cont == 1);
	}

	public void run()
	{
		boolean shellOk=false;
		String shell="";
		try {
			Properties p=new Properties();
			p.load(new FileInputStream("kabuk.prp"));
			if ((shell=p.getProperty("KABUK")) != null) {
				shellOk=true;
			}
		} catch (Exception e) {
			System.err.println("Uyari: Beklenmedik durum: "+e.getMessage());
		}
		readCommand();
		if (r_type == 1) {
			String cmd;
			remote_pwd=reply;
			REMOTE_PWD=remote_pwd.getBytes();
			while (not_exit) {
				System.out.write(PS1,0,PS1.length);
				System.out.write(REMOTE_PWD,0,REMOTE_PWD.length);
				System.out.write(PS2,0,PS2.length);
				try {
					cmd=stdin.readLine().trim();
					if (cmd.equals(BY) || cmd.equals(EXIT)) {
						return;
					} else if (cmd.length() > 0) {
						if (cmd.charAt(0) == '!') {
							if (cmd.length() == 1) {
								if (shellOk) {
									ProcessHandler p=new ProcessHandler();
									p.exec(shell);
								} else {
									System.err.println("Uyari: Kabuk istemcisi icin kabuk.prp dosyasinda KABUK=<kabuk ismi> belirterek tekrar baslatin");
								}
							} else {
								caller=USER;
								try {
									String [] cmds=splitCommand(cmd.substring(1));
									Method m=this.getClass().getMethod(cmds[0],ARGV);
									m.invoke(this,new Object[]{cmds,cmd});
								} catch (Exception e) {
									System.out.println("Beklenmedik Durum: "+e.getMessage());
								}
							}
						} else {
							try {
								writeBytes(cmd.getBytes());
								writeByte('\n');
								caller=SERVER;
								processResponse();
								no_to_all=false;
								not_yes_all=true;
							} catch (SocketException se) { }
						}
					}
				} catch(Exception e) {
					System.err.println("Beklenmedik Durum: "+e.getMessage());
				}
			}
		} else {
			System.out.println("Hata: Sunucu hata cevabi "+reply);
		}
	}
}
